Summary   	: Utilities for managing shadow password files and user/group accounts.
Name	  	: hhl-target-shadow
Version	  	: 20000902 
Release	  	: %{_hhl_build_id}.5
Source	  	: ftp://ftp.ists.pwr.wroc.pl/pub/linux/shadow/shadow_%{version}.orig.tar.gz
Source1		: shadow-LICENSE
Source2: shadow.tmpl
Patch0	  	: ftp://ftp.ists.pwr.wroc.pl/pub/linux/shadow/shadow_%{version}-6.1.diff.gz
Patch1		: shadow-initd.diff

License 	: Other
Group	  	: System Environment/Base
Buildroot 	: %{_tmppath}/%{name}-%{_hhl_target_arch}-root
Prefix	  	: %{_hhl_cross_target_dir}
%define _defaultdocdir	%{_hhl_cross_target_dir}%{_hhl_target_doc_dir}

#
#	SRPM
#
%description

This is the source RPM for the shadow-utils binary packages in Hard Hat
Linux.

#
#	RPM
#

%package -n hhl-%{_hhl_target_arch}-shadow
Summary		: Utilities for managing shadow password files and user/group accounts.
Group		: System Environment/Base
AutoReqProv	: no

%description -n hhl-%{_hhl_target_arch}-shadow

The shadow-utils package includes the necessary programs for
converting UNIX password files to the shadow password format, plus
programs for managing user and group accounts.  The pwconv command
converts passwords to the shadow password format.  The pwunconv command
unconverts shadow passwords and generates an npasswd file (a standard
UNIX password file).  The pwck command checks the integrity of
password and shadow files.  The lastlog command prints out the last
login times for all users.  The useradd, userdel and usermod commands
are used for managing user accounts.  The groupadd, groupdel and
groupmod commands are used for managing group accounts.

%prep

%target_check

%setup -n shadow-%{version}.orig

cp %{SOURCE1} LICENSE

%patch0 -p1
gunzip shadow-%{version}.tar.gz
tar -xvf shadow-%{version}.tar
cd shadow-20000902
patch -p1 < ../debian/patches/000_manpages.diff
patch -p1 < ../debian/patches/001_src_Makefile.am.diff
patch -p1 < ../debian/patches/002_src_login.c.diff
patch -p1 < ../debian/patches/003_src_newgrp.c.diff
patch -p1 < ../debian/patches/004_src_su.c.diff
patch -p1 < ../debian/patches/005_src_lastlogin.c.diff
patch -p1 < ../debian/patches/006_src_useradd.c.diff
patch -p1 < ../debian/patches/007_cppw.diff
patch -p1 < ../debian/patches/008_readonly_root.diff
patch -p1 < ../debian/patches/009_logoutd.diff
patch -p1 < ../debian/patches/010_src_passwd.c.diff
patch -p1 < ../debian/patches/011_doc_README.debian.diff
patch -p1 < ../debian/patches/012_libmisc_sulog.c.diff
patch -p1 < ../debian/patches/013_fix_shadowconfig
patch -p1 < ../debian/patches/014_libmisc_xmalloc.c.diff
patch -p1 < ../debian/patches/015_config_sub_guess.diff
patch -p1 < ../debian/patches/016_subsystem_shell_fix.diff
patch -p1 < ../debian/patches/017_su_root_hack.diff
patch -p1 < ../debian/patches/018_expiry_man_page.diff
patch -p1 < ../debian/patches/019_config_sub_guess.diff
%patch1 -p2

%build
PATH=%{_hhl_cross_bin_dir}:$PATH
%target_setup
%target_acplatvars

cd shadow-%{version}
%{_hhl_target_toolprefix}libtoolize --copy --force
export ac_cv_func_setpgrp=${ac_cv_func_setpgrp=yes}
export ac_cv_arg_setpgrp_negpid=${ac_cv_arg_setpgrp_negpid=yes}
export ac_cv_func_setpgrp_nargs=${ac_cv_func_setpgrp_nargs=0}
export ac_cv_func_setpgrp_void=${ac_cv_func_setpgrp_void=yes}

# Comment from debian is that shared lib support is untested..
# (It doesn't appear to work)
%target_configure --with-libpam --disable-shared --disable-desrpc

%make LDFLAGS="" CFLAGS=""

%install
%target_setup
PATH=%{_hhl_cross_bin_dir}:$PATH
rm -rf %{buildroot}
cd shadow-%{version}

mkdir -p %{buildroot}%{_hhl_cross_target_dir}/bin
mkdir -p %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_sysconf_dir}
mkdir -p %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_sysconf_dir}/cron.daily
mkdir -p %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_sysconf_dir}/pam.d
mkdir -p %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man1
mkdir -p %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man3
mkdir -p %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man5
mkdir -p %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man8

%target_makeinstall LDFLAGS="" CFLAGS=""

mv %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_bin_dir}/login %{buildroot}%{_hhl_cross_target_dir}/bin

# From binary-login:
        install -d %{buildroot}%{_hhl_cross_target_dir}/{bin,etc/init.d,usr/{bin,sbin}}
        install  -m0755 src/login %{buildroot}%{_hhl_cross_target_dir}/bin/
        install  -m4755 src/newgrp %{buildroot}%{_hhl_cross_target_dir}/usr/bin/
        install  src/{faillog,lastlog} %{buildroot}%{_hhl_cross_target_dir}/usr/bin/
        install  src/logoutd %{buildroot}%{_hhl_cross_target_dir}/usr/sbin/
        install -m644 ../man/{login.1,newgrp.1} %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man1/
        install -m644 ../man/{login.defs.5,login.access.5,porttime.5,faillog.5,limits.5} %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man5/
        install -m644 ../man/{faillog.8,logoutd.8,lastlog.8} %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man8/
        install -m600 ../etc/{login.access,limits} ../debian/{securetty,porttime} %{buildroot}%{_hhl_cross_target_dir}/etc/
        install -m600 ../debian/securetty %{buildroot}%{_hhl_cross_target_dir}/etc/securetty.example
	ln -s newgrp.1.gz %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man1/sg.1.gz
	install -m600 ../etc/login.defs.linux %{buildroot}%{_hhl_cross_target_dir}/etc/login.defs
	install ../debian/logoutd.init %{buildroot}%{_hhl_cross_target_dir}/etc/init.d/logoutd

# From binary-passwd:
	install -d %{buildroot}%{_hhl_cross_target_dir}{etc/{cron.daily,init.d},usr/{sbin,bin}}
	install ../debian/passwd.cron %{buildroot}%{_hhl_cross_target_dir}/etc/cron.daily/passwd
        install ../debian/passwd.init %{buildroot}%{_hhl_cross_target_dir}/etc/init.d/passwd
        install  -m4755 src/{chage,chfn,chsh,expiry,gpasswd,passwd} %{buildroot}%{_hhl_cross_target_dir}/usr/bin/
        install  src/{chpasswd,groupadd,groupdel,groupmod,grpck,grpconv,grpunconv} \
          src/{newusers,pwck,pwconv,pwunconv,useradd,userdel} \
          src/{dpasswd,usermod,vipw} %{buildroot}%{_hhl_cross_target_dir}/usr/sbin/
        install -m644 ../man/{chage.1,chfn.1,chsh.1,gpasswd.1,passwd.1} \
          %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man1/
        install -m644 ../man/{chpasswd.8,groupadd.8,groupdel.8,groupmod.8,grpck.8} \
          ../man/{newusers.8,pwck.8,dpasswd.8} \
          ../man/{useradd.8,userdel.8,usermod.8,vipw.8,shadowconfig.8,pwconv.8} \
          %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man8/
        install -m644 ../man/{passwd.5,shadow.5} %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man5/
	ln -s vipw %{buildroot}%{_hhl_cross_target_dir}/usr/sbin/vigr
	ln -s vipw.8.gz %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man8/vigr.8.gz
	for i in pwunconv.8.gz grpconv.8.gz grpunconv.8.gz ; do \
	  ln -s pwconv.8.gz %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man8/$i ; done
        install ../src/shadowconfig.sh %{buildroot}%{_hhl_cross_target_dir}/usr/sbin/shadowconfig
        
# from binary-su:
        install -d %{buildroot}%{_hhl_cross_target_dir}/{etc,bin,usr/}
        install -m4755 src/su %{buildroot}%{_hhl_cross_target_dir}/bin/
        install -m644 ../etc/suauth %{buildroot}%{_hhl_cross_target_dir}/etc/
        install -m644 ../man/suauth.5 %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man5/
        install -m644 ../man/su.1 %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man1/
	install -m644 ../../debian/local/chfn.pam.d %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_sysconf_dir}/pam.d/chfn  
	install -m644 ../../debian/local/chsh.pam.d %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_sysconf_dir}/pam.d/chsh 
	install -m644 ../../debian/local/login.defs.pam.linux %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_sysconf_dir}/login.defs 
	install -m644 ../../debian/local/login.pam.d %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_sysconf_dir}/pam.d/login  
	install -m644 ../../debian/local/passwd.pam.d %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_sysconf_dir}/pam.d/passwd 
	install -m644 ../../debian/local/su.pam.d %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_sysconf_dir}/pam.d/su

# gzip man pages
	find %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_man_dir} -type f | xargs gzip -9

# cleanup
	rm -f %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_bin_dir}/cppw
	ln -s cppw %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_sbin_dir}/cpgr


%demangle_libtool

install -d %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/pml/packages
export HHL_TOOL_PREFIX=%{_hhl_target_toolprefix}
genpkgdesc %{buildroot}%{_hhl_cross_target_dir} %{SOURCE2} > %{buildroot}%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/pml/packages/shadow

%clean
rm -rf %{buildroot}

%files -n hhl-%{_hhl_target_arch}-shadow
%defattr(-,root,root)
%{_hhl_cross_target_dir}/bin/*
%config %{_hhl_cross_target_dir}/etc/limits
%config %{_hhl_cross_target_dir}/etc/login.access
%config %{_hhl_cross_target_dir}/etc/login.defs
%config %{_hhl_cross_target_dir}/etc/porttime
%{_hhl_cross_target_dir}/etc/securetty.example
%config %{_hhl_cross_target_dir}/etc/suauth
%config %{_hhl_cross_target_dir}/etc/cron.daily/*
%config %{_hhl_cross_target_dir}/etc/init.d/*
%config %{_hhl_cross_target_dir}/etc/pam.d/*
%{_hhl_cross_target_dir}%{_hhl_target_bin_dir}/*
%{_hhl_cross_target_dir}%{_hhl_target_sbin_dir}/*
%{_hhl_cross_target_dir}%{_hhl_target_lib_dir}/*
%doc %{_hhl_cross_target_dir}%{_hhl_target_man_dir}/man?/*
%doc %{_hhl_cross_target_dir}%{_hhl_target_man_dir}/pl/man?/*
%doc LICENSE

%changelog
* Fri Apr 20 2001 Automated script (run by Steve Kinneberg <skinneberg@mvista.com>)
- Added TCT package description files
* Mon Feb 26 2001 Jeremy Puhlman <jpuhlman@mvista.com>
- first-cut hhl spec file
